CRunhtml5_pad.TYPICAL_BUTTON_COUNT = 16;
CRunhtml5_pad.TYPICAL_AXIS_COUNT = 4;
CRunhtml5_pad.ANALOGUE_BUTTON_THRESHOLD = 0.5;
CRunhtml5_pad.InitPad = function(){
	var gamepadSupportAvailable = navigator.getGamepads ||
		!!navigator.webkitGetGamepads ||
		!!navigator.webkitGamepads;
	if (!gamepadSupportAvailable) {
		//console.log("GamePads NotSupported");
	} else {
		if ('ongamepadconnected' in window) {
			window.addEventListener('gamepadconnected' , CRunhtml5_pad.onGamepadConnect, false);
			window.addEventListener('gamepaddisconnected' , CRunhtml5_pad.onGamepadDisconnect, false);
		} else {
			CRunhtml5_pad.startPolling();
		}
	}
},
CRunhtml5_pad.onGamepadConnect = function(event) {
	CRunhtml5_pad.gamepads.push(event.gamepad);
	CRunhtml5_pad.startPolling();
};
CRunhtml5_pad.onGamepadDisconnect = function(event) {
	for (var i in this.gamepads) {
		if (CRunhtml5_pad.gamepads[i].index == event.gamepad.index) {
			CRunhtml5_pad.gamepads.splice(i, 1);
			break;
		}
	}
	if (CRunhtml5_pad.gamepads.length == 0) {
		CRunhtml5_pad.stopPolling();
	}
};
CRunhtml5_pad.startPolling = function() {
	if (!CRunhtml5_pad.ticking) {
		CRunhtml5_pad.ticking = true;
		CRunhtml5_pad.tick();
	}
};
CRunhtml5_pad.stopPolling = function() {
	CRunhtml5_pad.ticking = false;
};
CRunhtml5_pad.pollStatus = function() {
	CRunhtml5_pad.pollGamepads();
	for (var i in CRunhtml5_pad.gamepads) {
		var gamepad = CRunhtml5_pad.gamepads[i];
		if (gamepad.timestamp &&
			(gamepad.timestamp == CRunhtml5_pad.prevTimestamps[i])) {
			continue;
		}
		CRunhtml5_pad.prevTimestamps[i] = gamepad.timestamp;
	}
};
CRunhtml5_pad.tick = function() {
	CRunhtml5_pad.pollStatus();
};
CRunhtml5_pad.pollGamepads = function() {
	var rawGamepads = (navigator.getGamepads && navigator.getGamepads()) ||
		(navigator.webkitGetGamepads && navigator.webkitGetGamepads());
	if (rawGamepads) {
		CRunhtml5_pad.gamepads = [];
		var gamepadsChanged = false;
		for (var i = 0; i < rawGamepads.length; i++) {
			if (typeof rawGamepads[i] != CRunhtml5_pad.prevRawGamepadTypes[i]) {
				gamepadsChanged = true;
				CRunhtml5_pad.prevRawGamepadTypes[i] = typeof rawGamepads[i];
			}
			if (rawGamepads[i]) {
				CRunhtml5_pad.gamepads.push(rawGamepads[i]);
			}
		}
	}
};
CRunhtml5_pad.getJoystick = function (gamepadId){
	if (!CRunhtml5_pad.ticking) return 0;
	var gamepad = CRunhtml5_pad.gamepads[gamepadId];
	if( typeof gamepad === "undefined" || typeof gamepad.buttons === "undefined" ){
		CRunhtml5_pad.ticking = false;
		return 0;
	}
	var k = 0;
	if( CRunhtml5_pad.getButton( gamepad , 12 ) || ( CRunhtml5_pad.getAxes( gamepad , 1 ) <= -0.4) ) k |= 1;
	if( CRunhtml5_pad.getButton( gamepad , 13 ) || ( CRunhtml5_pad.getAxes( gamepad , 1 ) >=  0.4) ) k |= 2;
	if( CRunhtml5_pad.getButton( gamepad , 14 ) || ( CRunhtml5_pad.getAxes( gamepad , 0 ) <= -0.4) ) k |= 4;
	if( CRunhtml5_pad.getButton( gamepad , 15 ) || ( CRunhtml5_pad.getAxes( gamepad , 0 ) >=  0.4) ) k |= 8;
	
	k |= (CRunhtml5_pad.getButton( gamepad , 0 )<<4);
	k |= (CRunhtml5_pad.getButton( gamepad , 1 )<<5);
	k |= (CRunhtml5_pad.getButton( gamepad , 2 )<<6);
	k |= (CRunhtml5_pad.getButton( gamepad , 3 )<<7);
	if( CRunhtml5_pad.pt != 0 ){
		k |= (CRunhtml5_pad.getButton( gamepad , 4 )<<8);
		k |= (CRunhtml5_pad.getButton( gamepad , 5 )<<9);
		k |= (CRunhtml5_pad.getButton( gamepad , 6 )<<10);
		k |= (CRunhtml5_pad.getButton( gamepad , 7 )<<11);
		k |= (CRunhtml5_pad.getButton( gamepad , 8 )<<12);
		k |= (CRunhtml5_pad.getButton( gamepad , 9 )<<13);
		k |= (CRunhtml5_pad.getButton( gamepad , 10 )<<14);
		k |= (CRunhtml5_pad.getButton( gamepad , 11 )<<15);
	}
	return k;
};
CRunhtml5_pad.getButton = function( gamepad , num  ){
	if( typeof gamepad.buttons[num] !== "undefined" ){
		if( typeof gamepad.buttons[num].pressed !== "undefined" ){
			return gamepad.buttons[num].pressed;
		}else if( typeof gamepad.buttons[num].value !== "undefined" ){
			return gamepad.buttons[num].value;
		}
	}
	return 0;
};
CRunhtml5_pad.getAxes = function( gamepad , num  ){
	if( typeof gamepad.axes[num] !== "undefined" ){
		if( typeof gamepad.axes[num] !== "undefined" ){
			return gamepad.axes[num];
		}
	}
	return 0;
};
function CRunhtml5_pad(){
	CRunhtml5_pad.ticking = false;
	CRunhtml5_pad.gamepads = [];
	CRunhtml5_pad.prevRawGamepadTypes = [];
	CRunhtml5_pad.prevTimestamps = [];
	CRunhtml5_pad.pt = 0;
}
CRunhtml5_pad.prototype = CServices.extend(new CRunExtension(),{
	getNumberOfConditions: function (){
		return 0;
	},
	createRunObject: function (file, cob, version){
		return true;
	},
	handleRunObject: function (){
		CRunhtml5_pad.InitPad();
		if( typeof this.ho.hoAdRunHeader.rhApp.run.joyTest_base === "undefined" ){
			var that = this;
			this.ho.hoAdRunHeader.rhApp.run.joyTest_base = this.ho.hoAdRunHeader.rhApp.run.joyTest;
			this.ho.hoAdRunHeader.rhApp.run.joyTest = function(){
				that.ho.hoAdRunHeader.rhApp.run.joyTest_base();
				if (CRunhtml5_pad.ticking) {
					CRunhtml5_pad.tick();
					that.ho.hoAdRunHeader.rhPlayer[0] |= CRunhtml5_pad.getJoystick(0) & this.rhJoystickMask ;
					if( CRunhtml5_pad.pt != 0 ){
						var f = CRunhtml5_pad.getJoystick(0);
						CRunhtml5_pad.pt.rov.rvValueFlags &= 0xffff0000;
						CRunhtml5_pad.pt.rov.rvValueFlags |= f;
					}
				}
			}
		}
	},
	action: function (num, act){
		switch (num){
			case 0:
				var fix = act.getParamExpression(this.rh, 0);
				var id = 0x0000FFFF & fix;
				if( id < 0 || id > this.rhMaxObjects ) return ;
				var obj = this.ho.hoAdRunHeader.rhObjectList[id];
				if( obj == 0 || (obj.hoCreationId<<16)!=(0xFFFF0000 & fix) ) return;
				CRunhtml5_pad.pt = obj;
				break;
		}
	}
});